<template>
    <div class="row clearfix">
        <div class="col-md-12">
            <div
                v-if="error"
                class="alert alert-danger alert-dismissible fade show"
                role="alert"
            >
                {{ error }}
                <button
                    type="button"
                    class="close"
                    data-dismiss="alert"
                    aria-label="Close"
                    @click="error = ''"
                >
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div
                v-if="success"
                class="alert alert-success alert-dismissible fade show"
                role="alert"
            >
                {{ success }}
                <button
                    type="button"
                    class="close"
                    data-dismiss="alert"
                    aria-label="Close"
                    @click="success = ''"
                >
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
        </div>
        <div class="col-md-12">
            <div class="form-group">
                <cool-select
                    v-model="country"
                    :items="countries"
                    item-text="name"
                    :loading="loading"
                    :allowMobileScroll="false"
                    :placeholder="fields.country.title"
                    :inputElCustomAttributes="{ id: 'inputCountry' }"
                    :inputForTextClass="'form-control'"
                    :inputStyles="inputStyles"
                    disable-filtering-by-search
                    @search="onSearchCountry"
                >
                    <template #no-data>
                        {{ noData ? fields.country.msg1 : fields.country.msg2 }}
                    </template>
                    <template #item="{ item }">
                        <div class="item">
                            <div>
                                <span class="item-name"> {{ item.name }} </span>
                            </div>
                        </div>
                    </template>
                    <template v-if="loading" #input-end>
                        <!-- You can use your own loading spinner -->
                        <img
                            height="16px"
                            src="https://i.imgur.com/mTNe6tr.gif"
                            class="loading-indicator"
                        />
                    </template>
                </cool-select>
            </div>
        </div>
        <div class="col-md-6">
            <div class="form-group m-b-10">
                <input
                    v-model="rate.rate"
                    type="text"
                    class="form-control "
                    :placeholder="fields.exchange_rate"
                />
            </div>
        </div>
        <div class="col-md-6">
            <div class="form-group m-b-10">
                <input
                    v-model="rate.courrency"
                    type="text"
                    class="form-control "
                    :placeholder="fields.courrency"
                />
            </div>
        </div>
        <!-- <div class="col-md-12">
            <div class="checkbox">
                <input id="procheck2" type="checkbox" />
                <label for="procheck2">New task notifications</label>
            </div>
            <div class="checkbox">
                <input id="procheck3" type="checkbox" />
                <label for="procheck3">New friend request notifications</label>
            </div>
        </div> -->
        <div class="col-md-12">
            <button @click.prevent="crear()" class="btn btn-primary btn-round btn-block">
                Save Changes
            </button>
        </div>
    </div>
</template>

<script>
import { CoolSelect } from "vue-cool-select";
export default {
    components: { CoolSelect },
    props: ["trans"],
    mounted() {},
    data() {
        return {
            fields: this.trans.create,
            country: [],
            state: [],
            error: "",
            rate: {
                rate: '',
                courrency: ''
            },
            success: "",
            // simple example of items
            countries: [],
            // there will be a selected item
            selected: null,
            loading: false,
            timeoutId: null,
            noData: false,
            inputStyles: {
                "background-color": "rgba(0,0,0,0)",
                border: "1px solid #E3E3E3",
                "border-radius": "30px",
                color: "#2c2c2c",
                "line-height": "normal",
                "font-size": ".8571em",
                height: "auto",
                "-webkit-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-moz-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-o-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-ms-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                transition:
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-webkit-box-shadow": "none",
                "box-shadow": "none"
            }
        };
    },
    methods: {
        async onSearchCountry(search) {
            const lettersLimit = 2;

            this.noData = false;
            if (search.length < lettersLimit) {
                this.countries = [];
                this.loading = false;
                return;
            }
            this.loading = true;

            clearTimeout(this.timeoutId);
            this.timeoutId = setTimeout(async () => {
                const response = await fetch(`/api/data/countries/${search}`);

                this.countries = await response.json();

                this.loading = false;

                if (!this.countries.length) this.noData = true;
            }, 500);
        },
        crear() {
            let url = "/api/settings/rates";
            this.rate.country = this.country.id;
            axios
                .post(url, this.rate)
                .then(res => {
                    this.error = "";
                    this.success = res.data.message;
                    setTimeout(() => {
                        location.reload()
                    }, 3000);
                })
                .catch(err => {
                    this.error = err.response.data.message;
                    this.success = "";
                });
        },
    }
};
</script>
<style>
#inputCountry{
    padding: 10px 18px 10px 18px !important;
    background-color: rgba(0, 0, 0, 0);
    border: 1px solid #e3e3e3;
    border-radius: 30px;
    color: #2c2c2c;
    line-height: normal;
    font-size: inherit;
    height: auto;
    -webkit-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -moz-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -o-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -ms-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -webkit-box-shadow: none;
    box-shadow: none;
}
</style>
